/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	kubeovnv1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeHtbQoses implements HtbQosInterface
type FakeHtbQoses struct {
	Fake *FakeKubeovnV1
}

var htbqosesResource = schema.GroupVersionResource{Group: "kubeovn.io", Version: "v1", Resource: "htbqoses"}

var htbqosesKind = schema.GroupVersionKind{Group: "kubeovn.io", Version: "v1", Kind: "HtbQos"}

// Get takes name of the htbQos, and returns the corresponding htbQos object, and an error if there is any.
func (c *FakeHtbQoses) Get(ctx context.Context, name string, options v1.GetOptions) (result *kubeovnv1.HtbQos, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(htbqosesResource, name), &kubeovnv1.HtbQos{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.HtbQos), err
}

// List takes label and field selectors, and returns the list of HtbQoses that match those selectors.
func (c *FakeHtbQoses) List(ctx context.Context, opts v1.ListOptions) (result *kubeovnv1.HtbQosList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(htbqosesResource, htbqosesKind, opts), &kubeovnv1.HtbQosList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kubeovnv1.HtbQosList{ListMeta: obj.(*kubeovnv1.HtbQosList).ListMeta}
	for _, item := range obj.(*kubeovnv1.HtbQosList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested htbQoses.
func (c *FakeHtbQoses) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(htbqosesResource, opts))
}

// Create takes the representation of a htbQos and creates it.  Returns the server's representation of the htbQos, and an error, if there is any.
func (c *FakeHtbQoses) Create(ctx context.Context, htbQos *kubeovnv1.HtbQos, opts v1.CreateOptions) (result *kubeovnv1.HtbQos, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(htbqosesResource, htbQos), &kubeovnv1.HtbQos{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.HtbQos), err
}

// Update takes the representation of a htbQos and updates it. Returns the server's representation of the htbQos, and an error, if there is any.
func (c *FakeHtbQoses) Update(ctx context.Context, htbQos *kubeovnv1.HtbQos, opts v1.UpdateOptions) (result *kubeovnv1.HtbQos, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(htbqosesResource, htbQos), &kubeovnv1.HtbQos{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.HtbQos), err
}

// Delete takes name of the htbQos and deletes it. Returns an error if one occurs.
func (c *FakeHtbQoses) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(htbqosesResource, name, opts), &kubeovnv1.HtbQos{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeHtbQoses) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(htbqosesResource, listOpts)

	_, err := c.Fake.Invokes(action, &kubeovnv1.HtbQosList{})
	return err
}

// Patch applies the patch and returns the patched htbQos.
func (c *FakeHtbQoses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *kubeovnv1.HtbQos, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(htbqosesResource, name, pt, data, subresources...), &kubeovnv1.HtbQos{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.HtbQos), err
}
