/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	scheme "github.com/kubeovn/kube-ovn/pkg/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// HtbQosesGetter has a method to return a HtbQosInterface.
// A group's client should implement this interface.
type HtbQosesGetter interface {
	HtbQoses() HtbQosInterface
}

// HtbQosInterface has methods to work with HtbQos resources.
type HtbQosInterface interface {
	Create(ctx context.Context, htbQos *v1.HtbQos, opts metav1.CreateOptions) (*v1.HtbQos, error)
	Update(ctx context.Context, htbQos *v1.HtbQos, opts metav1.UpdateOptions) (*v1.HtbQos, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.HtbQos, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.HtbQosList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.HtbQos, err error)
	HtbQosExpansion
}

// htbQoses implements HtbQosInterface
type htbQoses struct {
	client rest.Interface
}

// newHtbQoses returns a HtbQoses
func newHtbQoses(c *KubeovnV1Client) *htbQoses {
	return &htbQoses{
		client: c.RESTClient(),
	}
}

// Get takes name of the htbQos, and returns the corresponding htbQos object, and an error if there is any.
func (c *htbQoses) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.HtbQos, err error) {
	result = &v1.HtbQos{}
	err = c.client.Get().
		Resource("htbqoses").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of HtbQoses that match those selectors.
func (c *htbQoses) List(ctx context.Context, opts metav1.ListOptions) (result *v1.HtbQosList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.HtbQosList{}
	err = c.client.Get().
		Resource("htbqoses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested htbQoses.
func (c *htbQoses) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("htbqoses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a htbQos and creates it.  Returns the server's representation of the htbQos, and an error, if there is any.
func (c *htbQoses) Create(ctx context.Context, htbQos *v1.HtbQos, opts metav1.CreateOptions) (result *v1.HtbQos, err error) {
	result = &v1.HtbQos{}
	err = c.client.Post().
		Resource("htbqoses").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(htbQos).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a htbQos and updates it. Returns the server's representation of the htbQos, and an error, if there is any.
func (c *htbQoses) Update(ctx context.Context, htbQos *v1.HtbQos, opts metav1.UpdateOptions) (result *v1.HtbQos, err error) {
	result = &v1.HtbQos{}
	err = c.client.Put().
		Resource("htbqoses").
		Name(htbQos.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(htbQos).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the htbQos and deletes it. Returns an error if one occurs.
func (c *htbQoses) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("htbqoses").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *htbQoses) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("htbqoses").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched htbQos.
func (c *htbQoses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.HtbQos, err error) {
	result = &v1.HtbQos{}
	err = c.client.Patch(pt).
		Resource("htbqoses").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
